- Qt 6.8
- Qt for VxWorks
- Qt 6.8.0 Reference Documentation

# Qt for VxWorks

Contact The Qt Company for more information: https://www.qt.io/contact-us/

## Qt for VxWorks Licensing

From the Qt 6.8 release onward, Qt for VxWorks is available under the Qt for Device Creation Enterprise (DCE) license. For more information, see Qt Pricing.

## Supported Architectures and VxWorks Releases

- Qt 6.7 is verified on VxWorks 23.09 Supported architecture is ARM-v7.

If you are interested in later Qt releases, please contact Qt professional services.

## Requirements for VxWorks

### Qt Widgets Applications

- POSIX support
- C++17 support

### Qt Quick 2 Applications

All features which are required for Qt Widgets applications, and in addition the following:

- GPU device (GPUDEV) for OpenGL ES 2.0

## Supported Modules

Most essential Qt modules and some add-on modules are supported.

### Supported Essential modules

Qt Module | Supported Features | Notes
--- | --- | ---
Qt Core |
Qt GUI |
Qt Network |
Qt Qml |
Qt Quick |
Qt Quick Controls |
Qt Quick Dialogs |
Qt Quick Layouts |
Qt Quick Test |
Qt Test |
Qt Widgets |

### Supported Add-Ons

Qt Add-Ons | Notes
--- | ---
Qt Concurrent |
Qt GRPC/Protobuf |
Qt Graphs |
Qt Image Formats |
Qt Multimedia |
Qt Native Interfaces |
Qt OpenGL |
Qt Quick 3D |
Qt Quick Compiler |
Qt Quick Effects |
Qt SQL |
Qt SVG |
Qt Virtual Keyboard |

Note: You can explicitly exclude unsupported or unused modules from the build via the -skip <module> option when running the configure tool.

## Platform Notes

With the release of Qt 5.0, Qt no longer contains its own window system implementation: QWS is no longer a supported platform. For single-process use cases, the Qt Platform Abstraction is a superior solution.

There is one plugin that is usable on VxWorks: EGLFS. The availability of this plugins depends on the configuration of Qt.

## Configuring for a Specific Device

Prepare your environment by installing VxWorks SDK and obtaining WindRiver license which is needed by installer and for building VxWorks images. Search for appropriate installer in {https://gallery.windriver.com/portal/products}.

Building Qt for a given device requires a Qt6 installation for compilation host, a toolchain and a sysroot. Additionally, some devices require vendor specific adaptation code for EGL and OpenGL 2.0 support.

### VxWorks image requirements

Qt for VxWorks requires certain VxWorks image bundles and components to be embedded in base software to make Qt compile and work properly. The list is by no means complete as it depends on hardware, software and system requirements of your project. However, the following table contains those that are mandatory for certain functionalities to work. Note also that these might change with VxWorks version.

Layer | Notes
--- | ---
`BUNDLE_POSIX` | This bundle is necessary for compatibility with POSIX-related functionalities which Qt requires.
`INCLUDE_TMP_DIR` `INCLUDE_RAM_DISK_FORMAT_HRFS` | Including these two components is necessary if you want to use QTemporaryFile. Note that you should also consider setting `TMP_DIR_SIZE` to appropriate value

## Building Qt6 for VxWorks

### Building Qt6 for host

When cross-building Qt6 for VxWorks, it's best practice to use host tools that use the same source code as cross-build does. This requires building Qt6 for host first, but only with limited subset of submodules:

- qtbase
- qtdeclarative
- qtquick3d
- qtshadertools

Make sure to have all necessary prerequisites for building Qt6 for host. Check details in Building Qt Sources.

The commands to configure, build, and install Qt6 for host are the following:

     ./configure \
         -cmake-generator "Ninja" \
         -extprefix <path_to_qt6_host_installation_dir> \
         -submodules qtbase,qtdeclarative,qtquick3d,qtshadertools \
         -nomake tests \
         -nomake examples \
         -- \
         -B <host_build_directory>
     cd <host_build_directory>
     ninja
     ninja install

After these commands, Qt6 for host is installed in `<path_to_qt6_host_installation_dir>`.

### Building Qt6 for target

Before running configure and building Qt 6 it is required to open VxWorks Development Shell in command prompt.

- Linux:

       cd <VxWorks installation directory>
       ./wrenv.sh -p vxworks

- Windows:

       cd <VxWorks installation directory>
       wrenv -p vxworks

Below is an example build configuration for the BD-SL-i.MX6. For most VxWorks boards the configure command looks very similar. By default, Qt 6 is configured to use shared libraries. To build Qt 6 statically, add `-static` option for configure.

Make sure that {WIND_CC_SYSROOT} environment variable is set to VxWorks VSB root directory.

     ./configure \
         -cmake-generator "Ninja" \
         -icu \
         -no-feature-timezone \
         -no-feature-vulkan \
         -platform vxworks-clang \
         -qt-host-path <path_to_qt6_host_installation_dir> \
         -sysroot <path_to_vxworks_vsb_dir>/fsl_imx6_<vsb_version>_VSB \
         -qpa "eglfs" \
         -DQT_QPA_EGLFS_INTEGRATION=eglfs_viv \
         -prefix /sd0:1/qt6rtp \
         -extprefix <path_to_host_dir>/qt6rtp \
         -nomake tools \
         -nomake examples \
         -- \
         -B <target_build_dir> \
         -DCMAKE_TOOLCHAIN_FILE="$WIND_CC_SYSROOT/mk/rtp.toolchain.cmake"

In case of building for DKM rather than RTP, use `-static` option and change the `CMAKE_TOOLCHAIN_FILE` value to `"$WIND_CC_SYSROOT/mk/dkm.toolchain.cmake"`

It is recommended to build Qt 6 using a shadow build. See Qt Configure Options for more information.

When configuration is successful, building and installing Qt6 for VxWorks takes place as follows:

     cd <target_build_dir>
     ninja
     ninja install

## Platform Plugins for VxWorks Devices

Qt for VxWorks supports EGLFS platform plugin for a native window substitution. Read more about its configuration in EGLFS.

## Running Qt Applications

The following example shows how to start an application when Qt 6 is built using shared libraries. With a statically built Qt 6, there is no need to use the LD_LIBRARY_PATH environment variable. This variable is only needed to point the location of VxWorks shared libraries (for example libc and OpenGL ES 2.0). It is not needed for Qt 6 static libraries.

     putenv "LD_LIBRARY_PATH=/sd0:1/lib"
     cd "/sd0:1"
     rtpSp("<Qt6_app>", 200, 0x100000, 0, 0x01000000)

## Limitations

### Video Memory

Systems with a fixed amount of dedicated video memory may need extra care before running Qt application based on Qt Quick or classes like QOpenGLWidget. The default setting may be insufficient for such applications, especially when they are displayed on a high resolution (for example, full HD) screen. In this case they might start failing in unexpected ways. It is therefore recommended to ensure that there is at least 128 MB of GPU memory available. For systems that do not have a fixed amount of memory reserved for the GPU this is not an issue.